#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

// liste chainée pour stocker les voisins d'un sommet
struct adj{
	unsigned int voisin;
	struct adj* suiv;
};
typedef struct adj adj_t;

struct graphe {
	int n;
	adj_t** lv; // listes des voisins		
};
typedef struct graphe graphe_t;

int main(int argc, char const *argv[])
{	
	graphe_t* g = malloc(sizeof(graphe_t));
	g->n = 4;
	g->lv = malloc(4*sizeof(adj_t*));
	
	// successeurs de 0: [1]
	g->lv[0] = malloc(sizeof(adj_t));
	g->lv[0]->voisin = 1;
	g->lv[0]->suiv = NULL;

	// successeurs de 1: [2, 3]
	g->lv[1] = malloc(sizeof(adj_t));
	g->lv[1]->voisin = 2;
	g->lv[1]->suiv = malloc(sizeof(adj_t));
	g->lv[1]->suiv->voisin = 3;
	g->lv[1]->suiv->suiv = NULL;

	//successeurs de 2: [0, 3]
	g->lv[2] = malloc(sizeof(adj_t));
	g->lv[2]->voisin = 0;
	g->lv[2]->suiv = malloc(sizeof(adj_t));
	g->lv[2]->suiv->voisin = 3;
	g->lv[2]->suiv->suiv = NULL;

	// successeurs de 3: []
	g->lv[3] = NULL;

	// Libérer la mémoire: A COMPLETER QUESTION


	return 0;
}